/* Create HSB images for FRET Ratio images (Ana Seixas) 
 * v0.1
*
* 
* 
* This macro should NOT be redistributed without author's permission. 
* Explicit acknowledgement to the ALM facility should be done in case of published articles (approved in C.E. 7/17/2017):     
* 
* "The authors acknowledge the support of i3S Scientific Platform Advanced Light Microscopy, 
* member of the national infrastructure PPBI-Portuguese Platform of BioImaging (supported by POCI-01-0145-FEDER-022122)."
* 
* Date: October/2019
* Author: Mafalda Sousa, mafsousa@ibmc.up.pt 
* Advanced Ligth Microscopy, I3S 
* PPBI-Portuguese Platform of BioImaging
*/


// Open Original image and duplicate Ch2
selectWindow("Original");
original = getTitle();
setSlice(2);
run("Duplicate...", " ");
C2_original = getTitle();
getStatistics(area, mean, min, max, std, histogram);
setMinAndMax(min, max);
run("8-bit");

selectWindow("FRET_RATIO");
ratio_FRET = getTitle();
roiManager("Select", 0);
getStatistics(area, mean, min, max, std, histogram);
getDimensions(width, height, channels, slices, frames)
roiManager("deselect");
setMinAndMax(min, max);//????
run("8-bit");


// Create empty result image
getDimensions(width, height, channels, slices, frames)
newImage("HSV", "RGB black", width, height, 1);
run("HSB Stack");

// Copy and Paste original in HSV, V channel

selectWindow(C2_original);
run("Select All");
run("Copy");
selectWindow("HSV");
setSlice(3);
run("Paste");

// Copy and Paste original in HSV, H channel
selectWindow(ratio_FRET);
//run("Multiply...", "value=0.5");
run("Select All");
run("Copy");

// Paste top-bottom scaled gradient into H channel
selectWindow("HSV");
setSlice(1);
run("Paste");

// Set saturation (S) channel to all white
setSlice(2);
setForegroundColor(255, 255, 255);
run("Select All");
run("Fill", "slice");

// Convert HSB to RGB
run("RGB Color");